intP1Peg=0
intP2Peg=0
intP1NewPos=0
intP2NewPos=0
intCurrentPlayer=1
intCurrentRoll=0
dlgTheBoardDialog=nil
vb=renoise.ViewBuilder()
math.randomseed(os.time())
renoise.tool():add_menu_entry {
    name = "Main Menu:Tools:BoardGame ...",
    invoke = function() EatMeBoardGame() end
}
function EatMeBoardGame()
    local DIALOG_MARGIN = renoise.ViewBuilder.DEFAULT_DIALOG_MARGIN
    local CONTENT_SPACING = renoise.ViewBuilder.DEFAULT_CONTROL_SPACING
    local bCheckNoDialog = (vb==nil)
    local bDialogInvisible = false
    if (not bCheckNoDialog) and (dlgTheBoardDialog~=nil) then
      if dlgTheBoardDialog.visible==true then
        -- dialog:show() at the end
      else
        vb=renoise.ViewBuilder()
        bDialogInvisible=true
      end
    else 
      vb=renoise.ViewBuilder()
      bDialogInvisible=true
    end
    if bCheckNoDialog or bDialogInvisible then
      dlgTheBoardDialog=renoise.app():show_custom_dialog(
        "BoardGame 1.2", 
        
        vb:column {
          margin = DIALOG_MARGIN,
          spacing = CONTENT_SPACING,
          
          vb:text {
             id = "txtLastRoll",
             text = "Last Roll: 0"
          },
          vb:bitmap {
             id = "imgDice",
             bitmap = "dice1.png"
          },
          vb:text {
             id = "txtStatus",
             text = "Status: Waiting for player " .. intCurrentPlayer .. " to roll the dice..."
          },
          vb:row {
            vb:button {
              id = "btnRollDice",
              text = "Roll Dice",
              width = 100,
              height = 50,
              notifier = function (i)
                if vb ~= nil then 
                  if intCurrentPlayer==1 then
                    if intP1Peg==33 or intP2Peg==33 then
                      intP1Peg=0
                      intP2Peg=0
                      intP1NewPos=0
                      intP2NewPos=0
                      for intPegMove0=0,33 do
                        vb.views["Peg1Pos"..tostring(intPegMove0)].bitmap="pos"..tostring(intPegMove0).."p1empty.png"
                        vb.views["Peg1Pos"..tostring(intPegMove0)].mode="button_color"
                      end
                      for intPegMove3=0,33 do
                        vb.views["Peg2Pos"..tostring(intPegMove3)].bitmap="pos"..tostring(intPegMove3).."p2empty.png"
                        vb.views["Peg2Pos"..tostring(intPegMove3)].mode="button_color"
                      end
                      vb.views.Peg1Pos0.bitmap="player1.png"
                      vb.views.Peg2Pos0.bitmap="player2.png"
                      vb.views.Peg1Pos0.mode="plain"
                      vb.views.Peg2Pos0.mode="plain"
                      vb.views.btnRollDice.text="P1: Roll Dice"
                      vb.views.txtLastRoll.text="Last Roll: Game Restart"
                      intCurrentPlayer=1
                      return false
                    end
                    intCurrentRoll=math.random(1, 6)
                    vb.views.imgDice.bitmap = "dice" .. tostring(intCurrentRoll) .. ".png"
                    vb.views.txtLastRoll.text = "Last Roll: Player 1: " .. tostring(intCurrentRoll)
                    intP1NewPos = intP1Peg + intCurrentRoll
                    if intP1NewPos > 32 then
                      for intPegMove0=0,32 do
                        vb.views["Peg1Pos"..tostring(intPegMove0)].bitmap="pos"..tostring(intPegMove0).."p1empty.png"
                        vb.views["Peg1Pos"..tostring(intPegMove0)].mode="button_color"
                      end
                      for intPegMove1=intP1Peg,33 do
                        vb.views["Peg1Pos"..tostring(intPegMove1)].bitmap="pos"..tostring(intPegMove1).."p1used.png"
                        vb.views["Peg1Pos"..tostring(intPegMove1)].mode="plain"
                      end
                      intP1Peg=33
                      vb.views.txtStatus.text="Status: Player 1 has won."
                      vb.views.btnRollDice.text="Restart Game"
                    else
                      if intP1NewPos==7 then
                        vb.views.txtStatus.text="Status: Player 1 moved to 7 and may roll again."
                        vb.views.btnRollDice.text="P1: Roll Dice"
                      elseif intP1NewPos==8 then
                        vb.views.txtStatus.text="Status: Player 1 moved to 8 and falls back to 2."
                        intP1NewPos = 2
                        intCurrentPlayer=2
                        vb.views.btnRollDice.text="P2: Roll Dice"
                      elseif intP1NewPos==16 then
                        vb.views.txtStatus.text="Status: Player 1 moved to 16 and falls back to 3."
                        intP1NewPos = 3
                        intCurrentPlayer=2
                        vb.views.btnRollDice.text="P2: Roll Dice"
                      elseif intP1NewPos==17 then
                        vb.views.txtStatus.text="Status: Player 1 moved to 17 and may roll again."
                        vb.views.btnRollDice.text="P1: Roll Dice"
                      elseif intP1NewPos==23 then
                        vb.views.txtStatus.text="Status: Player 1 moved to 23 and falls back to 13."
                        intP1NewPos = 13
                        intCurrentPlayer=2
                        vb.views.btnRollDice.text="P2: Roll Dice"
                      elseif intP1NewPos==24 then
                        vb.views.txtStatus.text="Status: Player 1 moved to 24 and may roll again."
                        vb.views.btnRollDice.text="P1: Roll Dice"
                      elseif intP1NewPos==32 then
                        vb.views.txtStatus.text="Status: Player 1 moved to 32 and falls back to 6."
                        intP1NewPos = 6
                        intCurrentPlayer=2
                        vb.views.btnRollDice.text="P2: Roll Dice"
                      else
                        intCurrentPlayer=2
                        vb.views.txtStatus.text="Status: Player 1 moved to " .. tostring(intP1NewPos) .. "."
                        vb.views.btnRollDice.text="P2: Roll Dice"
                      end
                      if intP1NewPos==intP2Peg then
                        intP2Peg=0
                        intP2NewPos=0
                        vb.views.txtStatus.text=vb.views.txtStatus.text .. " Player 2 on that spot got sent back to start."
                        for intPegMove2=0,32 do
                          vb.views["Peg2Pos"..tostring(intPegMove2)].bitmap="pos"..tostring(intPegMove2).."p2empty.png"
                          vb.views["Peg2Pos"..tostring(intPegMove2)].mode="button_color"
                        end
                        vb.views.Peg2Pos0.bitmap="player2.png"
                        vb.views.Peg2Pos0.mode="plain"
                      end
                      for intPegMove0=0,32 do
                        vb.views["Peg1Pos"..tostring(intPegMove0)].bitmap="pos"..tostring(intPegMove0).."p1empty.png"
                        vb.views["Peg1Pos"..tostring(intPegMove0)].mode="button_color"
                      end
                      for intPegMove1=intP1Peg,intP1NewPos do
                        vb.views["Peg1Pos"..tostring(intPegMove1)].bitmap="pos"..tostring(intPegMove1).."p1used.png"
                        vb.views["Peg1Pos"..tostring(intPegMove1)].mode="plain"
                      end
                      intP1Peg=intP1NewPos
                    end
                  elseif intCurrentPlayer==2 then
                    if intP1Peg==33 or intP2Peg==33 then
                      intP1Peg=0
                      intP2Peg=0
                      intP1NewPos=0
                      intP2NewPos=0
                      for intPegMove0=0,33 do
                        vb.views["Peg1Pos"..tostring(intPegMove0)].bitmap="pos"..tostring(intPegMove0).."p1empty.png"
                        vb.views["Peg1Pos"..tostring(intPegMove0)].mode="button_color"
                      end
                      for intPegMove3=0,33 do
                        vb.views["Peg2Pos"..tostring(intPegMove3)].bitmap="pos"..tostring(intPegMove3).."p2empty.png"
                        vb.views["Peg2Pos"..tostring(intPegMove3)].mode="button_color"
                      end
                      vb.views.Peg1Pos0.bitmap="player1.png"
                      vb.views.Peg2Pos0.bitmap="player2.png"
                      vb.views.Peg1Pos0.mode="plain"
                      vb.views.Peg2Pos0.mode="plain"
                      vb.views.btnRollDice.text="P1: Roll Dice"
                      vb.views.txtLastRoll.text="Last Roll: Game Restart"
                      intCurrentPlayer=1
                      return false
                    end
                    intCurrentRoll=math.random(1, 6)
                    vb.views.imgDice.bitmap = "dice" .. tostring(intCurrentRoll) .. ".png"
                    vb.views.txtLastRoll.text = "Last Roll: Player 2: " .. tostring(intCurrentRoll)
                    intP2NewPos = intP2Peg + intCurrentRoll
                    if intP2NewPos > 32 then
                      for intPegMove3=0,32 do
                        vb.views["Peg2Pos"..tostring(intPegMove3)].bitmap="pos"..tostring(intPegMove3).."p2empty.png"
                        vb.views["Peg2Pos"..tostring(intPegMove3)].mode="button_color"
                      end
                      for intPegMove2=intP2Peg,33 do
                         vb.views["Peg2Pos"..tostring(intPegMove2)].bitmap="pos"..tostring(intPegMove2).."p2used.png"
                         vb.views["Peg2Pos"..tostring(intPegMove2)].mode="plain"
                      end
                      intP2Peg=33
                      vb.views.txtStatus.text="Status: Player 2 has won."
                      vb.views.btnRollDice.text="Restart Game"
                    else
                      if intP2NewPos==7 then
                        vb.views.txtStatus.text="Status: Player 2 moved to 7 and may roll again."
                        vb.views.btnRollDice.text="P2: Roll Dice"
                      elseif intP2NewPos==8 then
                        vb.views.txtStatus.text="Status: Player 2 moved to 8 and falls back to 2."
                        intP2NewPos = 2
                        intCurrentPlayer=1
                        vb.views.btnRollDice.text="P1: Roll Dice"
                      elseif intP2NewPos==16 then
                        vb.views.txtStatus.text="Status: Player 2 moved to 16 and falls back to 3."
                        intP2NewPos = 3
                        intCurrentPlayer=1
                        vb.views.btnRollDice.text="P1: Roll Dice"
                      elseif intP2NewPos==17 then
                        vb.views.txtStatus.text="Status: Player 2 moved to 17 and may roll again."
                        vb.views.btnRollDice.text="P2: Roll Dice"
                      elseif intP2NewPos==23 then
                        vb.views.txtStatus.text="Status: Player 2 moved to 23 and falls back to 13."
                        intP2NewPos = 13
                        intCurrentPlayer=1
                        vb.views.btnRollDice.text="P1: Roll Dice"
                      elseif intP2NewPos==24 then
                        vb.views.txtStatus.text="Status: Player 2 moved to 24 and may roll again."
                        vb.views.btnRollDice.text="P2: Roll Dice"
                      elseif intP2NewPos==32 then
                        vb.views.txtStatus.text="Status: Player 2 moved to 32 and falls back to 6."
                        intP2NewPos = 6
                        intCurrentPlayer=1
                        vb.views.btnRollDice.text="P1: Roll Dice"
                      else
                        intCurrentPlayer=1
                        vb.views.txtStatus.text="Status: Player 2 moved to " .. tostring(intP2NewPos) .. "."
                        vb.views.btnRollDice.text="P1: Roll Dice"
                      end
                      if intP2NewPos==intP1Peg then
                        intP1Peg=0
                        intP1NewPos=0
                        vb.views.txtStatus.text=vb.views.txtStatus.text .. " Player 1 on that spot got sent back to start."
                        for intPegMove0=0,32 do
                          vb.views["Peg1Pos"..tostring(intPegMove0)].bitmap="pos"..tostring(intPegMove0).."p1empty.png"
                          vb.views["Peg1Pos"..tostring(intPegMove0)].mode="button_color"
                        end
                        vb.views.Peg1Pos0.bitmap="player1.png"
                        vb.views.Peg1Pos0.mode="plain"
                      end
                      for intPegMove3=0,32 do
                        vb.views["Peg2Pos"..tostring(intPegMove3)].bitmap="pos"..tostring(intPegMove3).."p2empty.png"
                        vb.views["Peg2Pos"..tostring(intPegMove3)].mode="button_color"
                      end
                      for intPegMove2=intP2Peg,intP2NewPos do
                        vb.views["Peg2Pos"..tostring(intPegMove2)].bitmap="pos"..tostring(intPegMove2).."p2used.png"
                        vb.views["Peg2Pos"..tostring(intPegMove2)].mode="plain"
                      end
                      intP2Peg=intP2NewPos
                    end
                  end
                  vb.views["Peg1Pos"..tostring(intP1Peg)].bitmap="player1.png"
                  vb.views["Peg2Pos"..tostring(intP2Peg)].bitmap="player2.png"
                  vb.views["Peg1Pos"..tostring(intP1Peg)].mode="plain"
                  vb.views["Peg2Pos"..tostring(intP2Peg)].mode="plain"
                end
              end  
            },
          },
          vb:row {
            vb:bitmap {
              id="Peg1Pos0",
              bitmap="pos0p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos1",
              bitmap="pos1p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos2",
              bitmap="pos2p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos3",
              bitmap="pos3p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos4",
              bitmap="pos4p1empty.png",
              mode="button_color"
          },
            vb:bitmap {
              id="Peg1Pos5",
              bitmap="pos5p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos6",
              bitmap="pos6p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos7",
              bitmap="pos7p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos8",
              bitmap="pos8p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos9",
              bitmap="pos9p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos10",
              bitmap="pos10p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos11",
              bitmap="pos11p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos12",
              bitmap="pos12p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos13",
              bitmap="pos13p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos14",
              bitmap="pos14p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos15",
              bitmap="pos15p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos16",
              bitmap="pos16p1empty.png",
              mode="button_color"
            },
          },
          vb:row {
            vb:bitmap {
              id="Peg1Pos33",
              bitmap="pos33p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos32",
              bitmap="pos32p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos31",
              bitmap="pos31p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos30",
              bitmap="pos30p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos29",
              bitmap="pos29p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos28",
              bitmap="pos28p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos27",
              bitmap="pos27p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos26",
              bitmap="pos26p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos25",
              bitmap="pos25p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos24",
              bitmap="pos24p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos23",
              bitmap="pos23p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos22",
              bitmap="pos22p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos21",
              bitmap="pos21p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos20",
              bitmap="pos20p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos19",
              bitmap="pos19p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos18",
              bitmap="pos18p1empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg1Pos17",
              bitmap="pos17p1empty.png",
              mode="button_color"
            },
          },
          vb:row {
            vb:text {
              text = " "
            },
          },
          vb:row {
            vb:bitmap {
              id="Peg2Pos33",
              bitmap="pos33p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos32",
              bitmap="pos32p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos31",
              bitmap="pos31p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos30",
              bitmap="pos30p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos29",
              bitmap="pos29p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos28",
              bitmap="pos28p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos27",
              bitmap="pos27p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos26",
              bitmap="pos26p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos25",
              bitmap="pos25p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos24",
              bitmap="pos24p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos23",
              bitmap="pos23p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos22",
              bitmap="pos22p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos21",
              bitmap="pos21p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos20",
              bitmap="pos20p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos19",
              bitmap="pos19p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos18",
              bitmap="pos18p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos17",
              bitmap="pos17p2empty.png",
              mode="button_color"
            },
          },
          vb:row {
            vb:bitmap {
              id="Peg2Pos0",
              bitmap="pos0p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos1",
              bitmap="pos1p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos2",
              bitmap="pos2p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos3",
              bitmap="pos3p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos4",
              bitmap="pos4p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos5",
              bitmap="pos5p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos6",
              bitmap="pos6p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos7",
              bitmap="pos7p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos8",
              bitmap="pos8p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos9",
              bitmap="pos9p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos10",
              bitmap="pos10p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos11",
              bitmap="pos11p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos12",
              bitmap="pos12p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos13",
              bitmap="pos13p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos14",
              bitmap="pos14p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos15",
              bitmap="pos15p2empty.png",
              mode="button_color"
            },
            vb:bitmap {
              id="Peg2Pos16",
              bitmap="pos16p2empty.png",
              mode="button_color"
            },
          },
        }
      )
    else
      dlgTheBoardDialog:show()
    end
    vb.views["Peg1Pos"..tostring(intP1Peg)].bitmap="player1.png"
    vb.views["Peg2Pos"..tostring(intP2Peg)].bitmap="player2.png"
    vb.views["Peg1Pos"..tostring(intP1Peg)].mode="plain"
    vb.views["Peg2Pos"..tostring(intP2Peg)].mode="plain"
    if intP1Peg==33 or intP2Peg==33 then
      vb.views.btnRollDice.text="Restart Game"
      vb.views.txtStatus.text="Status: Waiting for Game Restart."
    end
end
